<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>SiteStar建站之星在线升级</title>
	<style type="text/css">
	body {font-size:12px;margin:0;padding:0;}
	a {text-decoration:none;font-size:12px;color:#595959;}
	#main {margin:0 auto;width:500px;padding:10px;text-align:center;}
	#main span {font-size:14px;color:#FF0000;display:inline-block;margin:15px auto;}
	</style>
</head>

<body>

<div id="main">
<?php
//ob_start();

define('IN_CONTEXT', 1);
define('ROOT', dirname(__FILE__));
define('P_LIB', ROOT.'/../library');

include_once(ROOT.'/../config.php');
include_once(P_LIB.'/'.Config::$mysql_ext.'.php');

// 数据库连接
$db = new MysqlConnection(
    Config::$db_host,
    Config::$db_user,
    Config::$db_pass,
    Config::$db_name
);
if (Config::$enable_db_debug === true) {
    $db->debug = true;
}

$lock_file = ROOT.'/upgrade.lock';

// 数据表更新
$sql = <<<EOT
ALTER TABLE es_online_orders ADD COLUMN message TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL;
ALTER TABLE es_online_qqs CHANGE qqname qqname VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

UPDATE es_parameters SET val =  '16' WHERE `key` = 'PAGE_SIZE';
UPDATE es_parameters SET val =  'sitestar_v1.1 Build100518' WHERE `key` = 'SYSVER';
UPDATE es_parameters SET val =  '网站正在维护中，请稍候访问！谢谢！'  WHERE `key` = 'SITE_OFFLINE_MSG';
UPDATE es_parameters SET val =  'frontpage,mod_article,mod_auth,mod_cart,mod_category_a,mod_category_p,mod_counter,mod_download,mod_download_category,mod_friendlink,mod_lang,mod_media,mod_menu,mod_message,mod_navigation,mod_offline,mod_onlinepay,mod_order,mod_product,mod_qq,mod_static,mod_template,mod_tool,mod_user,mod_menu_item,mod_modules,mod_param,mod_payaccount,mod_site,mod_news,mod_statistics,mod_database,mod_filemanager,mod_backup,mod_wizard,mod_about,mod_marquee,'  WHERE `key` = 'ALLOWED_MOD';
UPDATE es_admin_menu_items SET `level` = '1' WHERE `module` = 'mod_navigation';
UPDATE es_admin_menu_items SET `level` = '1' WHERE `module` = 'mod_template';

REPLACE INTO ss_parameters (`key`, val) VALUES ('BANNER_ISLINK', 'no');
REPLACE INTO ss_parameters (`key`, val) VALUES ('BANNER_LINK_ADDR', '#');
REPLACE INTO ss_parameters (`key`, val) VALUES ('IS_MARKED', '0');
REPLACE INTO ss_parameters (`key`, val) VALUES ('WATER_MARK', '水印');
EOT;

if( file_exists($lock_file) )
{
	die('<span>升级被锁定，应该是已经升级过了，如果已经恢复数据请手动删除<br />'.str_replace(ROOT, '', $lock_file).'<br />之后再来刷新页面</span>');
}
else
{
	// 更新数据表
	dbupdate($sql);
	// 更新主体库
	fileupdate();
	// 生成upgrade.lock
	fopen( $lock_file, 'a+' );
	// 清空Cache文件
	clear_cache( ROOT.'/cache' );
	
	echo '<h3>恭喜您，已成功升级为SiteStar建站之星最新版本！</h3>';	
	echo '<span>SiteStar建站之星最新版本需要模板的支持，如果您正在使用SiteStar官方提供的模板，请你到论坛(http://bbs.sitestar.cn/forum-21-1.html)下载最新版本模板！若你自己设计模板请参考模板更新细则： http://www.sitestar.cn/bbs/thread-337-1-1.html</span>';
	echo '<div><a href="../index.php?_v=preview" target="_blank">返回SiteStar首页</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="../admin/" target="_blank">SiteStar后台管理中心</a></div>';
}

function dbupdate($query) 
{
	global $db;
	
	$query = str_replace("\r", "\n", str_replace(' ss_', ' '.Config::$tbl_prefix, $query));
	$expquery = explode(";\n", $query);

	foreach($expquery as $sql) {
		$sql = trim($sql);
		
		if($sql == '' || $sql[0] == '#') continue;

		if(strtoupper(substr($sql, 0, 12)) == 'CREATE TABLE') {
			$db->query(createtable($sql, Config::$mysqli_charset));
		} elseif (strtoupper(substr($sql, 0, 11)) == 'ALTER TABLE') {
			runquery_altertable($sql);
		} else {
			$db->query($sql);
		}
	}
}

function fileupdate( $topath = '.' )
{
	foreach( glob($topath.'/*') as $file ) {
		if ( $file == './index.php' ) {
			continue;
		} else {
			if ( is_dir($file) ) {
				if ( !file_exists(ROOT.'/.'.$file) ) mkdir( ROOT.'/.'.$file, 0777 );
				fileupdate( $file );
			} else {
				copy( $file, '.'.$file );
			}
		}
	}
}

function createtable($sql, $dbcharset) 
{
	$type = strtoupper(preg_replace("/^\s*CREATE TABLE\s+.+\s+\(.+?\).*(ENGINE|TYPE)\s*=\s*([a-z]+?).*$/isU", "\\2", $sql));
	$type = in_array($type, array('MYISAM', 'HEAP')) ? $type : 'MYISAM';
	return preg_replace("/^\s*(CREATE TABLE\s+.+\s+\(.+?\)).*$/isU", "\\1", $sql).
	(mysql_get_server_info() > '4.1' ? " ENGINE=$type default CHARSET=".$dbcharset : " TYPE=$type");
}

function runquery_altertable($sql) 
{
	global $db;
	$tablepre = Config::$tbl_prefix;
	$dbcharset = Config::$mysqli_charset;

	$updatesqls = parse_alter_table_sql($sql);

	foreach($updatesqls as $updatesql) {
		$successed = TRUE;

		if(is_array($updatesql) && !empty($updatesql[0])) {

			list($table, $action, $field, $sql) = $updatesql;

			if(empty($field) && !empty($sql)) {
				$query = "ALTER TABLE {$tablepre}{$table} ";
				if($action == 'INDEX') {
					$successed = $db->query("$query $sql", "SILENT");
				} elseif ($action == 'UPDATE') {
					$successed = $db->query("UPDATE {$tablepre}{$table} SET $sql", 'SILENT');
				}
			} elseif($tableinfo = get_table_columns($tablepre.$table)) {
				$fieldexist = isset($tableinfo[$field]) ? 1 : 0;

				$query = "ALTER TABLE {$tablepre}{$table} ";

				if($action == 'MODIFY') {
					$query .= $fieldexist ? "MODIFY $field $sql" : "ADD $field $sql";
					$successed = $db->query($query, 'SILENT');
				} elseif($action == 'CHANGE') {
					$field2 = trim(substr($sql, 0, strpos($sql, ' ')));
					$field2exist = isset($tableinfo[$field2]);

					if($fieldexist && ($field == $field2 || !$field2exist)) {
						$query .= "CHANGE $field $sql";
					} elseif($fieldexist && $field2exist) {
						$db->query("ALTER TABLE {$tablepre}{$table} DROP $field2", 'SILENT');
						$query .= "CHANGE $field $sql";
					} elseif(!$fieldexist && $fieldexist2) {
						$db->query("ALTER TABLE {$tablepre}{$table} DROP $field2", 'SILENT');
						$query .= "ADD $sql";
					} elseif(!$fieldexist && !$field2exist) {
						$query .= "ADD $sql";
					}
					$successed = $db->query($query);
				} elseif($action == 'ADD') {
					$query .= $fieldexist ? "CHANGE $field $field $sql" :  "ADD $field $sql";
					$successed = $db->query($query);
				} elseif($action == 'DROP') {
					if($fieldexist) {
						$successed = $db->query("$query DROP $field", "SILENT");
					}
					$successed = TRUE;
				}
			} else {
				$successed = 'TABLE NOT EXISTS';
			}
		}
	}
	return $successed;
}

function parse_alter_table_sql($s) 
{
	$arr = array();
	preg_match("/ALTER TABLE (\w+)/i", $s, $m);
	$tablename = substr($m[1], strlen(Config::$tbl_prefix));
	preg_match_all("/add column (\w+) ([^\n;]+)/is", $s, $add);
	preg_match_all("/drop column (\w+)([^\n;]*)/is", $s, $drop);
	preg_match_all("/change (\w+) ([^\n;]+)/is", $s, $change);
	preg_match_all("/add key ([^\n;]+)/is", $s, $keys);
	preg_match_all("/add unique ([^\n;]+)/is", $s, $uniques);
	foreach($add[1] as $k => $colname) {
		$attr = preg_replace("/(.+),$/", "\\1", trim($add[2][$k]));
		$arr[] = array($tablename, 'ADD', $colname, $attr);
	}
	foreach($drop[1] as $k => $colname) {
		$attr = preg_replace("/(.+),$/", "\\1", trim($drop[2][$k]));
		$arr[] = array($tablename, 'DROP', $colname, $attr);
	}
	foreach($change[1] as $k => $colname) {
		$attr = preg_replace("/(.+),$/", "\\1", trim($change[2][$k]));
		$arr[] = array($tablename, 'CHANGE', $colname, $attr);
	}
	foreach($keys[1] as $k => $colname) {
		$attr = preg_replace("/(.+),$/", "\\1", trim($keys[0][$k]));
		$arr[] = array($tablename, 'INDEX', '', $attr);
	}
	foreach($uniques[1] as $k => $colname) {
		$attr = preg_replace("/(.+),$/", "\\1", trim($uniques[0][$k]));
		$arr[] = array($tablename, 'INDEX', '', $attr);
	}
	return $arr;
}

function get_table_columns($table) 
{
	global $db;
	$tablecolumns = array();
	
	if(mysql_get_server_info() > '4.1') {
		$query =& $db->query("SHOW FULL COLUMNS FROM $table");
	} else {
		$query =& $db->query("SHOW COLUMNS FROM $table");
	}
	
	while($field =& $query->fetchRow()) {
		$tablecolumns[$field['Field']] = $field;
	}
	return $tablecolumns;
}

function clear_cache( $path ) 
{
	foreach( glob( $path.'/*' ) as $file )
	{
		if ( is_dir( $file ) ) {
			clear_cache( $file );
		} else {
			unlink( $file );
		}
	}
}

$db->close();
?>
</div>

</body>
</html>