<?php
if (!defined('IN_CONTEXT')) die('access violation error!');

class ModMedia extends Module {
    protected $_filters = array(
        'check_login' => '{show_image}{show_flash}'
    );
    
    private $_available_types = array('file', 'image', 'flash');
    
    public function show_image() {
    	$this->_layout = 'frontpage';
    	
        $img_src = trim(ParamHolder::get('img_src', ''));
        if (strlen($img_src) == 0) {
            $this->assign('json', Toolkit::jsonERR(__('No Image!')));
            return '_error';
        }
        $img_desc = trim(ParamHolder::get('img_desc', ''));
        $img_width = trim(ParamHolder::get('img_width', ''));
        $str_img_width = '';
        if (strlen($img_width) != 0) {
            $str_img_width = sprintf(' width="%s"', $img_width);
        }
        $img_height = trim(ParamHolder::get('img_height', ''));
        $str_img_height = '';
        if (strlen($img_height) != 0) {
            $str_img_height = sprintf(' height="%s"', $img_height);
        }
        
        $this->assign('img_src', $img_src);
        $this->assign('img_desc', $img_desc);
        $this->assign('str_img_width', $str_img_width);
        $this->assign('str_img_height', $str_img_height);
    }
    
    public function show_flash() {
    	$this->_layout = 'frontpage';
    	
        $flv_src = trim(ParamHolder::get('flv_src', ''));
        if (strlen($flv_src) == 0) {
            $this->assign('json', Toolkit::jsonERR(__('No Flash!')));
            return '_error';
        }
        $flv_width = trim(ParamHolder::get('flv_width', ''));
        $str_flv_width = '';
        if (strlen($flv_width) != 0) {
            $str_flv_width = sprintf(' width="%s"', $flv_width);
        }
        $flv_height = trim(ParamHolder::get('flv_height', ''));
        $str_flv_height = '';
        if (strlen($flv_height) != 0) {
            $str_flv_height = sprintf(' height="%s"', $flv_height);
        }
        
        $this->assign('flv_src', $flv_src);
        $this->assign('str_flv_width', $str_flv_width);
        $this->assign('str_flv_height', $str_flv_height);
    }
    
    public function file_picker() {
        $this->_layout = 'content';
        
        if (!$this->_requireAdmin()) {
            return '_error';
        }
    }
    
    public function image_picker() {
        $this->_layout = 'content';
        
        if (!$this->_requireAdmin()) {
            return '_error';
        }
        
        // 5/5/2010 Add >>
        $err = '';
        $wincls = 'NG';
        $maxsize = 2 * 1024 * 1024;
        $typeArr = array('image/bmp','image/gif','image/png','image/x-png','image/jpeg','image/pjpeg');
        $file_info =& ParamHolder::get('localfile', array(), PS_FILES);
        if ( sizeof($file_info) > 0 && isset($file_info['name']) )
        {
	        // 文件大小
	        if ( ($file_info['size'] == 0) || ($file_info['size'] > $maxsize) ) {
	        	$err = '上传大小限制:2M';
	        // 文件类型
        	} elseif ( !in_array( $file_info['type'], $typeArr ) ) {
	        	$err = '支持的文件类型:gif|jpg|png|bmp';	
	        } else {
	        	$dest = ROOT.'/upload/image/';
	        	if ( move_uploaded_file( $file_info['tmp_name'], $dest.$file_info['name'] ) ) {
	        		$wincls = 'OK';
	        		$this->assign('fname', $file_info['name']);
	        	} else { $err = '上传失败'; }
	        }
        }
        $this->assign('err', $err);
        $this->assign('wincls', $wincls);
        // 5/5/2010 Add <<
        
//        $curr_entry = trim(ParamHolder::get('ep', ''));
//        $dir_info =& $this->_listDir('image', $curr_entry);
        
        $image_id = trim(ParamHolder::get('imgid', ''));
        
//        $this->assign('dirs', $dir_info['dirs']);
//        $this->assign('files', $dir_info['files']);
//        $this->assign('pager', $dir_info['pager']);
//        $this->assign('curr_entry', str_replace("\\", "/", $dir_info['curr_entry']));
        
        $this->assign('imgid', $image_id);
    }
    
    public function flash_picker() {
        $this->_layout = 'content';
        
        if (!$this->_requireAdmin()) {
            return '_error';
        }
        
         // 5/5/2010 Add >>
        $err = '';
        $wincls = 'NG';
        $maxsize = 2 * 1024 * 1024;
        $typeArr = array('application/x-shockwave-flash','application/octet-stream');
        $file_info =& ParamHolder::get('localfile', array(), PS_FILES);
        if ( sizeof($file_info) > 0 && isset($file_info['name']) )
        {
	        // 文件大小
	        if ( ($file_info['size'] == 0) || ($file_info['size'] > $maxsize) ) {
	        	$err = '上传大小限制:2M';
	        // 文件类型
        	} elseif ( !in_array( $file_info['type'], $typeArr ) ) {
	        	$err = '支持的文件类型:swf|flv';
	        } else {
	        	$dest = ROOT.'/upload/flash/';
	        	if ( move_uploaded_file( $file_info['tmp_name'], $dest.$file_info['name'] ) ) {
	        		$wincls = 'OK';
	        		$this->assign('fname', $file_info['name']);
	        	} else { $err = '上传失败'; }
	        }
        }
        $this->assign('err', $err);
        $this->assign('wincls', $wincls);
        // 5/5/2010 Add <<
        
//        $curr_entry = trim(ParamHolder::get('ep', ''));
//        $dir_info =& $this->_listDir('flash', $curr_entry);
        
        $flash_id = trim(ParamHolder::get('flvid', ''));
        
//        $this->assign('dirs', $dir_info['dirs']);
//        $this->assign('files', $dir_info['files']);
//        $this->assign('pager', $dir_info['pager']);
//        $this->assign('curr_entry', $dir_info['curr_entry']);
        
        $this->assign('flvid', $flash_id);
    }
    
    private function _requireAdmin() {
        if (!ACL::requireRoles(array('admin'))) {
            $this->setVar('json', Toolkit::jsonERR(__('No Permission!')));
            return false;
        }
        return true;
    }
    
    private function &_listDir($media_type, $curr_entry) {
    	$root = ROOT.DS.'upload'.DS.strtolower($media_type);
		if (strpos(realpath($root.DS.$curr_entry), $root) === false) {
		    $curr_entry = '';
		}
		$curr_entry = str_replace($root, '', realpath($root.DS.$curr_entry));
		if ($curr_entry != DS) {
		    $curr_entry .= DS;
		}
		
		$dirs = array();
		$files = array();
		
		if (is_dir($root.$curr_entry)) {
		    $o_dir = dir($root.$curr_entry);
		    while (false !== ($entry = $o_dir->read())) {
		        if (preg_match('/^\./', $entry)) {
		            continue;
		        }
		
		        if (is_dir($root.$curr_entry.$entry)) {
		            $dirs[$curr_entry.$entry] = $curr_entry.$entry;
		        } else {
		            $files[] = $entry;
		        }
		    }
		    $o_dir->close();
		}
		
		asort($dirs);
		sort($files);
		
		$files_data =& $this->_pageFiles($files);
		
		$dir_info['dirs'] = $dirs;
		$dir_info['files'] = $files_data['files'];
		$dir_info['pager'] = $files_data['pager'];
		$dir_info['curr_entry'] = $curr_entry;
		
		return $dir_info;
    }
    
    private function &_pageFiles(&$files, $page_param = 'p') {
        $files_data = array();
        
        $pagefiles = array();
        $curr_page =& ParamHolder::get($page_param, 1);
        $start_index = intval(PAGE_SIZE) * ($curr_page - 1);
        $end_index = $start_index + PAGE_SIZE;
        if (sizeof($files) > 0) {
            for ($i = $start_index; $i < $end_index; $i++) {
                if (isset($files[$i])) {
                    $pagefiles[] = $files[$i];
                }
            }
        }
        $pager =& Pager::genPagerLinks($curr_page, sizeof($files), $page_param);
        
        $files_data['files'] = $pagefiles;
        $files_data['pager'] = $pager;
        
        return $files_data;
    }
}
?>
