<?php
if (!defined('IN_CONTEXT')) die('access violation error!');

class ModTool extends Module {
    protected $_filters = array(
        'check_login' => '{upload_img}'
    );
	public function img_edit_update() {
        
        $img_id =& ParamHolder::get('img_id', array());
		
        if ($img_id <=0) {
            $this->assign('json', Toolkit::jsonERR(__('Missing image information!')));
            return '_result';
        }
		$file_info =& ParamHolder::get('img_name', array(), PS_FILES);
		if (!empty($file_info["name"])) {
			if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_info["name"])) {
				Notice::set('mod_marquee/msg', __('File type error!'));
				Content::redirect('index.php?'.Html::uriquery('mod_tool', 'img_edit', array('id' => $img_id)));
			}
			if(file_exists(ROOT.'/upload/image/'.$file_info["name"])) {
				$file_info["name"] = Toolkit::randomStr(8).strrchr($file_info["name"],".");
			}
			if (!$this->_savelinkimg($file_info)) {
				Notice::set('mod_marquee/msg', __('Link image upload failed!'));
				Content::redirect('index.php?'.Html::uriquery('mod_tool', 'img_edit', array('id' => $img_id)));
			}
		}
		
        $is_member_only = ParamHolder::get('ismemonly', '0');
        try {
			//add image
			if (!empty($file_info["name"])) {
				$img_info['img_name'] = 'upload/image/'.$file_info["name"];
			}

            $img_info['img_type'] = '1';
            
            // Data operation
            $o_m = new Marquee($img_id);
            $o_m->set($img_info);
            $o_m->save();
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_result';
        }
        Notice::set('mod_marquee/msg', __('Link updated successfully!'));
        Content::redirect('index.php?'.Html::uriquery('mod_tool', 'new_mblock_s2',array("widget"=>"mod_marquee-marquee")));
    }
	public function img_edit() {
        $this->_layout = 'content';
        
        $id = ParamHolder::get('id', '0');
        if (intval($id) == '0') {
            $this->assign('json', Toolkit::jsonERR(__('Invalid ID!')));
            return '_error';
        }
       try {
            $curr_m = new Marquee($id);
            $this->assign('curr_m', $curr_m);
        } catch (Exception $ex) {
            $this->assign('json', Toolkit::jsonERR($ex->getMessage()));
            return '_error';
        }
        
    }
	public function upload_img() {
		$this->_layout = 'content';
		$this->assign('test', '1234');
	}
	public function img_delete() {
		$id = ParamHolder::get('id', '0');
		if (intval($id) == 0) {
            $this->setVar('json', Toolkit::jsonERR(__('Invalid ID!')));
            return '_result';
        }

        try {
        	$curr_m = new Marquee($id);
        	$curr_m->delete();
        } catch (Exception $ex) {
            $this->setVar('json', Toolkit::jsonERR($ex->getMessage()));
            return '_result';
        }

        Content::redirect('index.php?'.Html::uriquery('mod_tool', 'new_mblock_s2',array("widget"=>"mod_marquee-marquee")));
	}
	public function img_create() {
		$file_info =& ParamHolder::get('img_name', array(), PS_FILES);
		if ($file_info['error'] > 0) {
            Notice::set('mod_marquee/msg', __('Invalid post file data!'));
            Content::redirect('index.php?'.Html::uriquery('mod_tool', 'upload_img'));
        }
		if(!preg_match('/\.('.PIC_ALLOW_EXT.')$/i', $file_info["name"])) {
			Notice::set('mod_marquee/msg', __('File type error!'));
            Content::redirect('index.php?'.Html::uriquery('mod_marquee', 'upload_img'));
		}
        if(file_exists(ROOT.'/upload/image/'.$file_info["name"])) {
            $file_info["name"] = Toolkit::randomStr(8).strrchr($file_info["name"],".");
        }
        if (!$this->_savelinkimg($file_info)) {
            Notice::set('mod_marquee/msg', __('Link image upload failed!'));
            Content::redirect('index.php?'.Html::uriquery('mod_marquee', 'upload_img'));
        }
		try {
            $mod_marquee['img_name'] = 'upload/image/'.$file_info["name"];
           
			$mod_marquee['img_type'] = '1';
            
            // Data operation
            $o_m = new Marquee();
            $o_m->set($mod_marquee);
            $o_m->save();
        } catch (Exception $ex) {
            Notice::set('mod_marquee/msg', $ex->getMessage());
            Content::redirect('index.php?'.Html::uriquery('mod_tool', 'upload_img'));
        }
        
        Notice::set('mod_marquee/msg', __('Link added successfully!'));
        Content::redirect('index.php?'.Html::uriquery('mod_tool', 'new_mblock_s2',array("widget"=>"mod_marquee-marquee")));
	}
    public function upd_position() {
        if (!$this->_requireAdmin()) {
            return '_result';
        }

        foreach (TplInfo::$positions as $pos) {
            $target_pos = trim(ParamHolder::get('SZ_'.$pos, ''));
            if (strlen($target_pos) == 0) {
                continue;
            }
            parse_str(urldecode($target_pos));
            $n_modblk = sizeof($MODBLK);
            if ($n_modblk > 0) {
                try {
                    for ($i = 0; $i < $n_modblk; $i++) {
                        if (is_numeric($MODBLK[$i])) {
                            $curr_block = new ModuleBlock($MODBLK[$i]);
                            if ($curr_block) {
                                $curr_block->s_pos = $pos;
                                $curr_block->i_order = $i;
                                $curr_block->save();
                            }
                        }
                    }
                } catch (Exception $ex) {
                    $this->setVar('json', Toolkit::jsonERR($ex->getMessage()));
                    return '_result';
                }
            }
            unset($MODBLK);
        }

        $this->setVar('json', Toolkit::jsonOK());
        return '_result';
    }

    public function new_mblock_s1() {
        $this->_layout = 'content';

        if (!$this->_requireAdmin()) {
            return '_error';
        }

        include_once(P_INC.'/widgets.php');
        if (empty($widgets)) {
            $this->setVar('json', Toolkit::jsonERR(__('No widgets defined!')));
            return '_error';
        }

        // Arrange widgets info
        global $userlevels;
        $widgets_info = array();
        foreach($widgets as $w_module => $w_actions) {
            if (check_mod($w_module)) {
                foreach($w_actions as $w_action => $w_info ) {
                    $widgets_info[$w_module.'-'.$w_action] = __($w_info['name']);
                }
            }
        }

        $this->assign('widgets_info', $widgets_info);
    }

    public function new_mblock_s2() {
        $this->_layout = 'content';

        if (!$this->_requireAdmin()) {
            return '_error';
        }

        $currpos = ParamHolder::get('currpos', 'center');
        $this->assign('currpos', $currpos);
        
        $widget = ParamHolder::get('widget', '');
        list($w_module, $w_action) = explode('-', $widget);
        if (strlen(trim($w_module)) == 0 || strlen(trim($w_action)) == 0) {
            $this->setVar('json', Toolkit::jsonERR(__('Invalid widget info111!')));
            return '_error';
        }
        $this->assign('w_module', $w_module);
        $this->assign('w_action', $w_action);

        include_once(P_INC.'/widgets.php');
        $this->assign('params', $widgets[$w_module][$w_action]['parameters']);

        $this->assign('roles', Toolkit::loadAllRoles());
        $this->assign('positions', Toolkit::reformPositions());
    }

    public function add_mblock() {
        if (!$this->_requireAdmin()) {
            return '_result';
        }

        $mb_data =& ParamHolder::get('mb', array());
        $is_member_only = ParamHolder::get('ismemonly', '0');
        try {
        	$mb_data['alias'] = 'mb_'.Toolkit::randomStr(8);
            $curr_mblock = new ModuleBlock();
            $curr_mblock->set($mb_data);
            if ($mb_data['show_title']) {
                $curr_mblock->show_title = '1';
            } else {
                $curr_mblock->show_title = '0';
            }
            /* [Disable publish status temporarily] */
            /*
            if ($mb_data['published']) {
                $curr_mblock->published = '1';
            } else {
                $curr_mblock->published = '0';
            }
            */
            $curr_mblock->published = '1';
            // Assign default data
            $curr_mblock->s_locale = SessionHolder::get('_LOCALE', DEFAULT_LOCALE);

            $query_str = '';
            $dispage = trim(ParamHolder::get('dispage', ''));
            if (!empty($dispage)) {
                $url_info = parse_url($dispage);
                if (isset($url_info['query'])) {
                    $query_str = trim($url_info['query']);
                }
            }
            if (ParamHolder::get('dispallpg', false)) {
                $curr_mblock->s_query_hash = '_ALL';
            } else {
                $curr_mblock->s_query_hash = Toolkit::calcMQHash($query_str);
            }
            $curr_mblock->i_order = '-1';
            $curr_mblock->for_roles = ACL::explainAccess(intval($is_member_only));
            
            // Now collect extra parameters
        	include_once(P_INC.'/widgets.php');
        	$params = $widgets[$curr_mblock->module][$curr_mblock->action]['parameters'];
            $ex_params =& ParamHolder::get('ex_params', array());
            if (!empty($params)) {
            	foreach ($params as $param) {
            	    if (!isset($ex_params[$param['id']])) {
            	    	// 28/4/2010 Add >>
            	    	$multiple = false;
            	    	$category = array();
            	    	$key = str_replace('[]', '', $param['id']);
			            $category = & ParamHolder::get( $key, array() );
			            if ( is_array($category) && sizeof($category) ) {
			            	$multiple = true;
			            	$category_list = join(',', $category);
			            }
            	    	
            	        if ($multiple) {
            	        	$ex_params[$key] = $category_list;
            	        } else { // 28/4/2010 Add <<
            	        	//$ex_params[$param['id']] = '';
            	        	$ex_params[$key] = '';
            	        }
            	    }
            	}
                $curr_mblock->s_param = serialize($ex_params);
            }
            $curr_mblock->save();
        } catch (Exception $ex) {
            $this->setVar('json', Toolkit::jsonERR($ex->getMessage()));
            return '_result';
        }

        $this->setVar('json', Toolkit::jsonOK());
        return '_result';
    }

    public function edit_prop() {
        $this->_layout = 'content';

        if (!$this->_requireAdmin()) {
            return '_error';
        }

        $mb_id = ParamHolder::get('mb_id', '0');
        if (intval($mb_id) == 0) {
            $this->setVar('json', Toolkit::jsonERR(__('Invalid block ID!')));
            return '_error';
        }
        $curr_mblock = new ModuleBlock($mb_id);
        $this->assign('curr_mblock', $curr_mblock);

        include_once(P_INC.'/widgets.php');
        $this->assign('params', $widgets[$curr_mblock->module][$curr_mblock->action]['parameters']);

        $this->assign('roles', Toolkit::loadAllRoles());
    }

    public function save_prop() {
        if (!$this->_requireAdmin()) {
            return '_result';
        }

        $mb_data =& ParamHolder::get('mb', array());
        if (!isset($mb_data['id']) || intval($mb_data['id']) <= 0) {
            $this->setVar('json', Toolkit::jsonERR(__('Invalid block ID!')));
            return '_result';
        }
        $is_member_only = ParamHolder::get('ismemonly', '0');
        try {
            $curr_mblock = new ModuleBlock($mb_data['id']);
            $curr_mblock->set($mb_data);
            if ($mb_data['show_title']) {
                $curr_mblock->show_title = '1';
            } else {
                $curr_mblock->show_title = '0';
            }
            /* [Disable publish status temporarily] */
            /*
            if ($mb_data['published']) {
                $curr_mblock->published = '1';
            } else {
                $curr_mblock->published = '0';
            }
            */
            $curr_mblock->published = '1';
            // Assign default data
            $curr_mblock->s_locale = SessionHolder::get('_LOCALE', DEFAULT_LOCALE);

            $query_str = '';
            $dispage = trim(ParamHolder::get('dispage', ''));
            if (!empty($dispage)) {
                $url_info = parse_url($dispage);
                if (isset($url_info['query'])) {
                    $query_str = trim($url_info['query']);
                }
            }
            if (ParamHolder::get('dispallpg', false)) {
                $curr_mblock->s_query_hash = '_ALL';
            } else {
                $curr_mblock->s_query_hash = Toolkit::calcMQHash($query_str);
            }
            //$curr_mblock->s_query_hash = '_ALL';
            $curr_mblock->for_roles = ACL::explainAccess(intval($is_member_only));
            
            // Now collect extra parameters
        	include_once(P_INC.'/widgets.php');
        	$params = $widgets[$curr_mblock->module][$curr_mblock->action]['parameters'];
            $ex_params =& ParamHolder::get('ex_params', array());
            if (!empty($params)) {
            	foreach ($params as $param) {
            	    if (!isset($ex_params[$param['id']])) {
            	    	// 28/4/2010 Add >>
            	    	$multiple = false;
            	    	$category = array();
			            $key = str_replace('[]', '', $param['id']);
			            $category = & ParamHolder::get( $key, array() );
			            if ( is_array($category) && sizeof($category) ) {
			            	$multiple = true;
			            	$category_list = join(',', $category);
			            }
            	        if ($multiple) {
            	        	$ex_params[$key] = $category_list;
            	        } else { // 28/4/2010 Add <<
            	        	//$ex_params[$param['id']] = '';
            	        	$ex_params[$key] = '';
            	        }
            	    }
            	}
                $curr_mblock->s_param = serialize($ex_params);
            }
            $curr_mblock->save();
        } catch (Exception $ex) {
            $this->setVar('json', Toolkit::jsonERR($ex->getMessage()));
            return '_result';
        }

        $this->setVar('json', Toolkit::jsonOK());
        return '_result';
    }

    public function rm_mblock() {
        if (!$this->_requireAdmin()) {
            return '_result';
        }

        $mb_id = ParamHolder::get('mb_id', '0');
        if (intval($mb_id) == 0) {
            $this->setVar('json', Toolkit::jsonERR(__('Invalid block ID!')));
            return '_result';
        }

        $block_id = '0';
        $block_alias = '';
        try {
        	$curr_mblock = new ModuleBlock($mb_id);
        	$block_id = $curr_mblock->id;
        	$block_alias = $curr_mblock->alias;
        	$curr_mblock->delete();
        } catch (Exception $ex) {
            $this->setVar('json', Toolkit::jsonERR($ex->getMessage()));
            return '_result';
        }

        $this->setVar('json', Toolkit::jsonOK(array('dom_id' => 'MODBLK_'.$block_id)));
        return '_result';
    }

    private function _requireAdmin() {
        if (!ACL::requireRoles(array('admin'))) {
            $this->setVar('json', Toolkit::jsonERR(__('No Permission!')));
            return false;
        }
        return true;
    }
	 private function _savelinkimg($struct_file) {
    	$struct_file['name'] = iconv("UTF-8", "gb2312", $struct_file['name']);
        return move_uploaded_file($struct_file['tmp_name'], ROOT.'/upload/image/'.$struct_file['name']);
    }
}
?>
